/*
 ATtiny84 Si4432 RX Test
 Version: 1.0
 Author: Alex from insideGadgets (http://www.insidegadgets.com)
 Created: 3/02/2017
 Last Modified: 3/02/2017
 
 */

#define F_CPU 1000000

#include <avr/io.h>
#include <avr/wdt.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <string.h>
#include <avr/pgmspace.h>
#include <avr/sleep.h>
#include "si4432.c"
#include "setup.c"

// ATtiny24/44/84 Pin map
//
//               +-\/-+
//         VCC  1|o   |14  GND
//         PB0  2|    |13  PA0 LED
//         PB1  3|    |12  PA1
//         PB3  4|    |11  PA2 SS
//         PB2  5|    |10  PA3 IRQ
//         PA7  6|    |9   PA4 SCK
//    MOSI PA6  7|    |8   PA5 MISO
//               +----+

int main(void) {
	setup();
	
	while(1) {
		wait_for_valid_packet();
		clear_data_in();
		
		// Read from address
		uint8_t fromAddress = spi_read_reg(RH_RF22_REG_48_RECEIVED_HEADER2);
		
		// Read the packet
		uint8_t packetlength = spi_read_reg(RH_RF22_REG_4B_RECEIVED_PACKET_LENGTH);
		spiBurstRead(RH_RF22_REG_7F_FIFO_ACCESS, dataIn, packetlength);
		
		// Check the type of request
		uint8_t requestType = spi_read_reg(RH_RF22_REG_49_RECEIVED_HEADER1);
		if (requestType == CHECK_IN) { // Client check in
			if (strncmp("Hello World!", (char*) dataIn, 12) == 0) {
				PORTA |= (1<<PA0);
				_delay_ms(20);
				PORTA &= ~(1<<PA0);
				_delay_ms(20);
			}
		}
	}
}
