/*
 ATtiny84 Si4432 TX Test
 Version: 1.0
 Author: Alex from insideGadgets (http://www.insidegadgets.com)
 Created: 3/02/2017
 Last Modified: 3/02/2017
 
 */

#define F_CPU 1000000

#include <avr/io.h>
#include <avr/wdt.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <string.h>
#include <avr/pgmspace.h>
#include <avr/sleep.h>
#include "si4432.c"
#include "setup.c"

// ATtiny24/44/84 Pin map
//
//               +-\/-+
//         VCC  1|o   |14  GND
//         PB0  2|    |13  PA0 LED
//         PB1  3|    |12  PA1
//         PB3  4|    |11  PA2 SS
//         PB2  5|    |10  PA3 IRQ
//         PA7  6|    |9   PA4 SCK
//    MOSI PA6  7|    |8   PA5 MISO
//               +----+

int main(void) {
	setup();
	
	while(1) {
		RH_RF22_resetFifos();
		
		RH_RF22_txHeaderTo = RH_SENSOR1;
		RH_RF22_txHeaderRequestType = CHECK_IN;
		
		uint8_t data_out[] = "Hello World!";
		RH_RF22_send(data_out, sizeof(data_out));
		
		// Wait for packet to be sent
		uint8_t readReg = 0;
		while (!(readReg & enpksent)) {
			readReg = spi_read_reg(RH_RF22_REG_03_INTERRUPT_STATUS1);
			_delay_ms(5);
		}
		
		PORTA |= (1<<PA0);
		_delay_ms(50);
		PORTA &= ~(1<<PA0);
	}
}
